<mat-horizontal-stepper [linear]="isLinear" #stepper class="full-width-table full-width-table-xs full-width-table-md dee-container">
    <!-- change default 'edit' icon -->
    <ng-template matStepperIcon="edit">
        <mat-icon>done</mat-icon>
    </ng-template>
    
    <mat-step [stepControl]="firstFormGroup">
        <form [formGroup]="firstFormGroup" class="rules-form" fxFlex="100%" fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center left">
            <ng-template matStepLabel>Descriptor Metadata</ng-template>
            <mat-form-field appearance="outline" class="rules-full-width">
                <mat-label>Experiment Blueprint</mat-label>
                <mat-select formControlName="expBlueprintId" name="expBId" (selectionChange)="onExpBSelected($event);">
                    <mat-option *ngFor="let expB of expBlueprints" [value]="expB.value">
                        {{expB.viewValue}}
                    </mat-option>
                </mat-select>
            </mat-form-field>
            <mat-form-field appearance="outline" color=primary class="rules-full-width">
                <input matInput #descName placeholder="Name" formControlName="expDescName" required>
            </mat-form-field>
            <mat-form-field appearance="outline" color=primary class="rules-full-width">
                <input matInput #descVersion placeholder="Version" formControlName="expDescVersion" required>
            </mat-form-field>
            <div class="margin-top">
                <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="firstFormGroup.invalid">Next</button>
            </div>
        </form>
    </mat-step>


    <!-- <mat-step [stepControl]="secondFormGroup">
        <form [formGroup]="secondFormGroup" class="rules-form">
            <ng-template matStepLabel>VS Descriptor</ng-template>
            
            <mat-form-field appearance="outline" color=primary class="rules-full-width">
                <input matInput placeholder="Name" formControlName="vsDescName" required>
            </mat-form-field>
           
            <mat-form-field appearance="outline" color=primary class="rules-full-width">
                <input matInput placeholder="Version" formControlName="vsDescVersion" required>
            </mat-form-field>
         
            <mat-expansion-panel class="dee-table">
              <mat-expansion-panel-header>
                  <mat-panel-title>QoS Parameters</mat-panel-title>
              </mat-expansion-panel-header>
              <div *ngFor="let param of vsBlueprint['parameters']; let i=index">
                  <mat-form-field appearance="outline" class="rules-full-width">
                      <mat-label>{{param.parameterId}}</mat-label>
                      <input matInput [id]="'qos_' + param.parameterId">
                  </mat-form-field>
              </div>
          </mat-expansion-panel>
         
        <div class="margin-top"></div>
            <div *ngFor="let con of activeCoverageAreas; let i = index;">
                <mat-expansion-panel class="dee-table">
                    <mat-expansion-panel-header>
                        <mat-panel-title>Slice Parameters For {{con.coverageArea}}</mat-panel-title>
                    </mat-expansion-panel-header>
                    <mat-form-field appearance="outline" color=primary class="rules-full-width">
                        <mat-label>Radio Access Technology</mat-label>
                          <mat-select formControlName="radioAccessTechnology" name="radioAccessTechnology" (selectionChange)="selectRATElement($event,con.coverageArea,'radio', i);">
                            <mat-option *ngFor="let radio of con.rat" [value]="radio" class="dee-table">
                                {{radio}}
                            </mat-option>
                        </mat-select>
                    </mat-form-field>
                    <div *ngIf="con.sst === 'EMBB'">
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <input matInput #descName placeholder="Uplink Throughput"  (keyup)="selectRATElement($event,con,'Uplink', i);">
                        </mat-form-field>
                        <mat-form-field appearance="outline" color=primary class="rules-full-width" >
                            <input matInput #descName placeholder="Downlink Throughput"  (keyup)="selectRATElement($event,con,'Downlink', i);">
                        </mat-form-field>

                    </div>
                    <div *ngIf="con.sst === 'URLLC'">
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <input matInput #descName placeholder="latency"  (keyup)="selectRATElement($event,con,'latency', i);">
                        </mat-form-field>
                    </div>
                </mat-expansion-panel>
                <div class="margin-top"></div>
            </div>
            <div class="margin-top">
                <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
                <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="false">Next</button>
            </div>
        </form>
    </mat-step> -->
    
    
    
    
    <mat-step [stepControl]="thirdFormGroup">
        <form [formGroup]="thirdFormGroup" class="rules-form">
          <ng-template matStepLabel>KPIs</ng-template>
          <div *ngFor="let metric of expBlueprint['kpis']; let i=index">
            <mat-label style="color: black;" >{{metric.name}}</mat-label>
              <mat-form-field appearance="outline" color=primary class="rules-full-width">
                  <mat-label>{{metric.name}}: lowerBound</mat-label>
                  <input matInput [id]="'metric_' + metric.kpiId + 'lowerBound'">
              </mat-form-field>
              <mat-form-field appearance="outline" color=primary class="rules-full-width">
                <mat-label>{{metric.name}}: upperBound</mat-label>
                <input matInput [id]="'metric_' + metric.kpiId + 'upperBound'">
            </mat-form-field>
        </div>
          <div class="margin-top">
              <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
              <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="thirdFormGroup.invalid" click="display()">Next</button>
              <!-- <button mat-raised-button color="accent" class="margin-all submitBtn" (click)="createOnBoardExpDescriptorRequest();" [disabled]="thirdFormGroup.invalid">Submit</button> -->
          </div>
      </form>
      </mat-step>

<!-- 
    <mat-step [stepControl]="fourthFormGroup">
        <form [formGroup]="fourthFormGroup" class="rules-form">
            <ng-template matStepLabel>Context Details</ng-template>
            <div *ngFor="let ctx of ctxBlueprints">
                <mat-expansion-panel class="dee-table">
                    <mat-expansion-panel-header>
                        <mat-panel-title>{{ctx.viewValue}}</mat-panel-title>
                    </mat-expansion-panel-header>
                    <div *ngFor="let param of ctx.item['parameters']; let i=index">
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <mat-label>{{param.parameterId}}</mat-label>
                            <input matInput id={{param.parameterId}}>
                        </mat-form-field>
                    </div>
                </mat-expansion-panel>
            </div>
            <div class="margin-top">
                <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
                <button mat-raised-button matStepperNext color="primary" class="margin-all nextBtn" [disabled]="fourthFormGroup.invalid">Next</button>
            </div>
        </form>
    </mat-step> -->
    <mat-step [stepControl]="fifthFormGroup">
        <form [formGroup]="fifthFormGroup" class="rules-form">
            <ng-template matStepLabel>Test Cases Configuration</ng-template>
            <div *ngIf="input.length > 0">
                <h4 style="color: black;">Execution Action</h4>
            <!-- <div *ngFor="let item of input;">
                <mat-label style="color: black;" >{{item}}</mat-label>
                <mat-form-field appearance="outline" color=primary class="rules-full-width">
                    <mat-label >{{item}}</mat-label>
                    <input matInput placeholder="value" formControlName="actionValue">
                </mat-form-field>
            </div> -->
            <div formArrayName="executionaction_param" *ngFor="let executionaction_par of fifthFormGroup.get('executionaction_param')['controls']; let i=index">
                <div [formGroupName]="i" fxFlex="100%"  fxLayout.xs="column"  fxLayout="row" fxLayoutAlign="center center" style="width: 100%;">
                    <h5  style="margin-right:10px">Param {{i + 1}}</h5>
                    <td>
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <input matInput placeholder="value" formControlName="actionValue">
                        </mat-form-field>
                    </td>
                </div>
            </div>

            <h4 style="color: black;">Configuration Action</h4>
            
            <div formArrayName="configurationaction_param" *ngFor="let configurationaction_para of fifthFormGroup.get('configurationaction_param')['controls']; let i=index">
                <div [formGroupName]="i" fxFlex="100%"  fxLayout.xs="column"  fxLayout="row" fxLayoutAlign="center center" style="width: 100%;">
                    <h5  style="margin-right:10px">Param {{i + 1}}</h5>
                    <td>
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <input matInput placeholder="value" formControlName="CAinputParamName">
                        </mat-form-field>
                    </td>
                </div>
            </div>

            <h4 style="color: black;">Reset Action</h4>
            <div formArrayName="resetaction_param" *ngFor="let resetaction_para of fifthFormGroup.get('resetaction_param')['controls']; let i=index">
                <div [formGroupName]="i" fxFlex="100%"  fxLayout.xs="column"  fxLayout="row" fxLayoutAlign="center center" style="width: 100%;">
                    <h5  style="margin-right:10px">Param {{i + 1}}</h5>
                    <td>
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <input matInput placeholder="value" formControlName="RAinputParamName">
                        </mat-form-field>
                    </td>
                </div>
            </div>
        </div>
        
            <!-- <div *ngFor="let tc of tcBlueprints; let i=index">
                <mat-expansion-panel class="dee-table">
                    <mat-expansion-panel-header>
                        <mat-panel-title>{{tc.viewValue}}</mat-panel-title>
                    </mat-expansion-panel-header>
                    <h4>User Parameters</h4>
                    <div *ngFor="let param of tc.item['userParameters'] | keyvalue">
                        <mat-form-field appearance="outline" color=primary class="rules-full-width">
                            <mat-label>{{param.key}}</mat-label>
                            <input matInput [id]="'user_' + param.key">
                        </mat-form-field>
                    </div>
                    

                </mat-expansion-panel>
            </div> -->
            <div class="margin-top">
                <button mat-raised-button matStepperPrevious color="primary" class="margin-all backBtn">Back</button>
                <button mat-raised-button (click)="stepper.reset()" color="warn" class="margin-all resetBtn">Reset</button>
                <button mat-raised-button color="accent" class="margin-all submitBtn" (click)="createOnBoardExpDescriptorRequest();" [disabled]="fifthFormGroup.invalid">Submit</button>
            </div>
        </form>
    </mat-step>
</mat-horizontal-stepper>
